<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: chart/PolarChart.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: chart/PolarChart.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'd3', 'ss', 'uweaver/lang', 'uweaver/dom', 'uweaver/widget/Widget',
    'uweaver/data/Collection', './axis/RadialAxis', './axis/AngularAxis', './series/PieSeries',
    './series/RadarSeries'], function(_, $, d3, ss, lang, dom, Widget, Collection, RadialAxis, AngularAxis, PieSeries, RadarSeries) {

    var declare = lang.declare;
    var Base = Widget;

    var PADDING = 10, WIDTH = 200, HEIGHT = 200;


    /**
     * A PolarChart visualizes its data points using the Polar coordinate system.
     *
     * ##### JavaScript
     *
     *     var OrderCubes = declare(Collection, {
     *        resource: 'orderCubes',
     *        area: function(options) {
     *            this.sync('area', {}, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        }
     *     });

     *     var cubes = new OrderCubes();
     *
     *     // Generate a pie chart.
     *
     *     cubes.area({async: false});
     *
     *     var pieChartNode = $('[name=pieChart]');
     *     var pieChart = new PolarChart({
     *        el: pieChartNode,
     *        data: cubes,
     *        title: "Revenue by Area",
     *     }).render();
     *
     *     pieChart.addSeries({
     *          type: PolarChart.SERIES.PIE,
     *          angleField: 'amount',
     *          labelField: 'area'
     *     });
     *
     *     // Generate a donut chart
     *
     *     cubes.area({async: false});
     *
     *     var donutChartNode = $('[name=donutChart]');
     *     var donutChart = new PolarChart({
     *        el: donutChartNode,
     *        data: cubes,
     *        title: "Revenue by Area",
     *     }).render();
     *
     *     pieChart.addSeries({
     *          type: PolarChart.SERIES.PIE,
     *          angleField: 'amount',
     *          labelField: 'area',
     *          donut: 0.5,
     *          tooltips: {display: 'none'}
     *     });
     *
     *     // Get the legend of the added series.
     *     var legend = chart.getSeries(0).legend();
     *     expect(legend).to.be.an.instanceof(Array);
     *     expect(legend[0]).to.be.an.instanceof(Object);
     *     expect(legend[0].label).to.equal(cubes.at(0).get('area'));
     *     expect(legend[0].color).to.not.be.empty;
     *     expect(legend[0].percentage).to.be.above(0);
     *
     * ##### HTML
     *     &lt;svg name="pieChart" style="width:700px;height:400px;">
     *     &lt;/svg>
     *
     *     &lt;svg style="width:700px;height:400px;">
     *          &lt;g name="donutChart">
     *          &lt;/g>
     *     &lt;/svg>
     *
     *
     * #### JSON
     *     URL: orderCubes/area
     *     Response:
     *     {
     *       "status" : 200,
     *       "items" : [{
     *         "amount": 1200,
     *         "cost": 1000,
     *         "area": "north"
     *       }, {
     *           "amount": 800,
     *           "cost": 750,
     *           "area": "south"
     *       }, {
     *           "amount": 2200,
     *           "cost": 1800,
     *           "area": "east"
     *       }, {
     *           "amount": 2300,
     *           "cost": 1830,
     *           "area": "west"
     *       }]
     *     }
     *
     *
     * ##### Events:
     * + 'transition' - [data()]{@link PolarChart#data}
     *
     * @constructor PolarChart
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {Collection} [config.data=new Collection()] - A collection to specify the models to display.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            style: {}
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._component = d3.select(this.el);
        this._axes = {};
        this._series = [];
        this._anchors = {};

        this._color = d3.scale.category10();

        (cfg.data) ? this.data(cfg.data, {render: false}) : this.data(new Collection(), {render: false});
        cfg.width &amp;&amp; this.width(cfg.width); cfg.height &amp;&amp; this.height(cfg.height);

        this.css(cfg.style);

        var anchors = this._anchors;
        anchors.chart = this._component.append('g').attr('name', 'chart');
        anchors.canvas = anchors.chart.append('g').attr('name', 'canvas');
        anchors.title = anchors.chart.append('text').style({
            'font-size': '20px',
            'text-anchor': 'middle',
            'fill': this.color()
        }).attr('name', 'title');
        this.title(cfg.title);

        anchors.axes = [];

        _.each(cfg.axes, function(cfg) {
            var selection = anchors.chart.append('g');
            var axis;
            if(cfg.position===PolarChart.POSITION.ANGULAR) {
                axis = new AngularAxis({
                    el: selection.node(),
                    type: cfg.type,
                    title: cfg.title,
                    tickFormat: cfg.tickFormat,
                    unit: cfg.unit,
                    style: {
                        'font-size': '12px',
                        stroke: this.color(),
                        fill: this.color()
                    }
                });
            } else if(cfg.position===PolarChart.POSITION.RADIAL) {
                axis = new RadialAxis({
                    el: selection.node(),
                    type: cfg.type,
                    tickFormat: cfg.tickFormat,
                    title: cfg.title,
                    unit: cfg.unit,
                    style: {
                        'font-size': '12px',
                        stroke: this.color(),
                        fill: this.color()
                    }
                });
            }

            this._axes[cfg.position] = axis;
            anchors.axes[cfg.position] = selection;
        }, this);

        if(!_.has(this._axes, PolarChart.POSITION.RADIAL)) {
            var selection = anchors.chart.append('g');
            var axis = new RadialAxis({
                el: selection.node(),
                style: {
                    'font-size': '12px',
                    stroke: this.color(),
                    fill: this.color()
                }
            });
            this._axes[PolarChart.POSITION.RADIAL] = axis;
            anchors.axes[PolarChart.POSITION.RADIAL] = selection;
        }

        if(!_.has(this._axes, PolarChart.POSITION.ANGULAR)) {
            var selection = anchors.chart.append('g');
            var axis = new AngularAxis({
                el: selection.node(),
                style: {
                    'font-size': '12px',
                    stroke: this.color(),
                    fill: this.color()
                }
            });
            this._axes[PolarChart.POSITION.ANGULAR] = axis;
            anchors.axes[PolarChart.POSITION.ANGULAR] = selection;
        }

        _.each(cfg.series, function(cfg) {
            this.addSeries(cfg);
        }, this);

    }

    function render(options) {
        var defaults = {
            hidden: false
        };

        options || (options = {});
        _.defaults(options, defaults);

        var anchors = this._anchors;
        var axes = this._axes;
        var series = this._series;

        // optimize axes' domain.
        measure.call(this);

        layout.call(this);

        // optimize axes' range.
        coordinate.call(this);

        /**
         * @todo render axes
         */

        // render series.
        _.each(series, function(sequence) {
            sequence.render();

        }, this);

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function measure() {
        var series = this._series;
        var axes = this._axes;
        var data = this._data;

        _.each(axes, function(axis) {
            var extent = [];

            _.each(series, function(sequence) {
                var field;
                if(sequence.angularAxis()===axis) {
                    field = sequence.angleField();
                } else if(sequence.radialAxis()===axis) {
                    field = sequence.radiusField();
                } else {
                    return;
                }
                if(axis.type()===PolarChart.AXIS.NUMERICAL) {
                    extent = data.reduce(function(extent, item) {
                        var value = item[field] ? item[field]() : item.get(field);
                        extent[0] = extent[0] ? Math.min(extent[0], value) : value;
                        extent[1] = extent[1] ? Math.max(extent[1], value) : value;
                        return extent;
                    }, extent);
                } else if(axis.type()===PolarChart.AXIS.TIME) {
                    extent = data.reduce(function(extent, item) {
                        var value = item[field] ? item[field]() : item.get(field);
                        extent[0] = extent[0] ? Math.min(extent[0], value) : value;
                        extent[1] = extent[1] ? Math.max(extent[1], value) : value;
                        return extent;
                    }, extent);
                } else {
                    extent = _.union(extent, data.map(function(item) {
                        return item[field] ? item[field]() : item.get(field);
                    }));
                }
            });
            axis.domain(extent);
        });
    }

    function layout() {
        var margin = {top: PADDING*2, right: PADDING*2, bottom: PADDING*2, left: PADDING*2};
        var anchors = this._anchors;
        var axes = this._axes;
        var sizes = {};

        _.each(axes, function(axis) {
            if(axis instanceof AngularAxis) return;
            var size = axis.sizing();
            var margin = size.outerRadius - size.innerRadius;
            margin.top = margin.top + margin;
            margin.right = margin.right + margin;
            margin.bottom = margin.bottom + margin;
            margin.left = margin.left + margin;
        });

        if(this.title() &amp;&amp; this.title().length>0) {
            var size = dom.sizing(anchors.title);
            margin.top = margin.top + size.height + PADDING;
            sizes.title = size;
        }

        var width = this.width() - margin.left - margin.right;
        var height = this.height() - margin.top - margin.bottom;


        anchors.canvas.attr({
            'transform': 'translate(' + (margin.left + width / 2) + ',' + (margin.top + height / 2) + ')'
        });

        if(this.title() &amp;&amp; this.title().length>0) {
            anchors.title.attr({
                x: margin.left + width / 2,
                y: PADDING + sizes.title.height
            });
        }

        this._margin = margin;
    }


    function title(text) {
        var anchors = this._anchors;

        if(arguments.length===0) {
            return anchors.title.text();
        }

        anchors.title.text(text);

        if(text &amp;&amp; text.length>0) {
            anchors.title.style('display', '')
        } else {
            anchors.title.style('display', 'none');
        }
    }

    /**
     * optimize axes' range.
     */
    function coordinate() {
        var radialAxis = this._axes[PolarChart.POSITION.RADIAL];
        var margin = this._margin;
        var width = this.width() - margin.left - margin.right;
        var height = this.height() - margin.top - margin.bottom;
        var radius = Math.min(height, width) / 2;
        var range = [0, radius];

        radialAxis.range(range);
    }

    function addSeries(series) {
        series || (series = {});
        var color = this.color(this._series.length);

        var defautls = {
            style: {
                fill: color,
                stroke: color
            }
        };

        _.defaults(series, defautls);

        var anchors = this._anchors;
        var selection = anchors.canvas.append('g');

        series.el = selection.node();
        series.data = this._data;
        series.angularAxis = this._axes[PolarChart.POSITION.ANGULAR];
        series.radialAxis = this._axes[PolarChart.POSITION.RADIAL];


        if(series.type===PolarChart.SERIES.PIE) {
            this._series.push(new PieSeries(series));
        } else if(series.type===PolarChart.SERIES.RADAR) {
            this._series.push(new RadarSeries(series));
        }

        this.isRendered() &amp;&amp; this.render();
    }

    function getSeries(index) {
        return this._series[index];
    }

    function clear() {

        _.each(this._series, function(series) {
            series.destroy();
        });

        this._series = [];
    }

    /**
     *
     * Draw the grid lines.
     *
     * @private
     * @param position
     * @param options
     * @returns {grid}
     */
    function gridline(position, options) {
        options || (options = {});
        var defaults = {
            stroke: 'grey',
            'stroke-width': '0.5px'
        };
        _.defaults(options, defaults);

        //var canvas = this.canvas();

        //canvas.selectAll('[name=' + position + '] g.tick line').attr(options);

        return this;
    }



    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof PolarChart#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the chart from being rendered.
     * @returns {Collection}
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        this._dataset = items.toArray();

        this.listenTo(this._data, "update", _.bind(onItemsUpdate, this));

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this._data;
    }

    function onItemsUpdate() {
        this.refresh();
    }

    function refresh() {

    }

    function canvas() {
        return this._canvas;
    }

    /**
     * @override
     */
    function width(value) {
        if(!value) {
            return this.$el.outerWidth() || this.cfg().width || WIDTH;
        }

        this.$el.outerWidth(value);
    }

    /**
     * @override
     */
    function height(value) {
        if(!value) {
            return this.$el.outerHeight() || this.cfg().height || HEIGHT;
        }

        this.$el.outerHeight(value);
    }

    function color(index) {
        return this._color(index)
    }

    var props = {
        _components: undefined,
        _title: undefined,
        _data: undefined,
        _axes: undefined,
        _margin: undefined,
        _measurement: undefined,
        _color: undefined,
        tagName: 'g'

    };

    var PolarChart = declare(Base, {
        initialize: initialize,
        render: render,
        data: data,
        title: title,
        addSeries: addSeries,
        color: color,
        height: height,
        width: width,
        clear: clear,
        getSeries: getSeries
    }, props);

    PolarChart.AXIS = {
        NUMERICAL: "NUMERICAL",
        CATEGORICAL: "CATEGORICAL"
    };

    PolarChart.SERIES = {
        PIE: "PIE",
        RADAR: "RADAR"
    };

    PolarChart.POSITION = {
        ANGULAR: "ANGULAR",
        RADIAL: "RADIAL"
    };
    

    return PolarChart;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
